//+------------------------------------------------------------------+
//|                                                   +JoGET#58+.mq4 |
//|                                        Copyright  2008, masemus |
//|                                                 Gresik@Indonesia |
//+------------------------------------------------------------------+
#property copyright "masemus"
#property link      "masemus@yahoo.com"

#property indicator_chart_window

//---- Pos!
extern int window       = 0;
extern int corner       = 3;

//---- BBAO
int FastMA       = 5;
int SlowMA       = 12;
int MA_Mode      = MODE_EMA;
int MA_PriceType = PRICE_CLOSE;
int BBperiode    = 10;
double StDv      = 1;

//---- BuySell
extern color DN_clr     = DeepPink;
extern color UP_clr     = DodgerBlue;
extern color SW_clr     = DarkGray;
extern color tDN_clr    = LightPink;
extern color tUP_clr    = LightSkyBlue;
extern color tSW_clr    = LightGray;
extern color Time_clr   = Magenta;
extern color Spread_clr = RosyBrown;
extern color Text_clr   = Silver;

//---- MarketToday :: Mtr
extern color DN0_clr    = Yellow;
extern color DN1_clr    = Gold;
extern color DN2_clr    = Orange;
extern color DN3_clr    = DarkOrange;
extern color DN4_clr    = OrangeRed;
extern color DN5_clr    = Red;
extern color UP0_clr    = GreenYellow;
extern color UP1_clr    = LightGreen;
extern color UP2_clr    = LimeGreen;
extern color UP3_clr    = MediumSeaGreen;
extern color UP4_clr    = SeaGreen;
extern color UP5_clr    = Green;
extern color SW0_clr    = DarkGray;
extern color SW2dn_clr  = LightPink;
extern color SW2up_clr  = LightSkyBlue;


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {    
  //*****************************************************************************************************
   //Info
   string Teks="", Teks_Menit, Teks_Detik;
   double d_A, d_B;

   //Time for Next Candle
   d_B = (Time[4]-Time[5])-MathMod(CurTime(),Time[4]-Time[5]);
   d_A = d_B/60;
   d_B = (d_A-MathFloor(d_A))*60;
   d_A = MathFloor(d_A);
   Teks_Menit = DoubleToStr(d_A,0);
   Teks_Detik = DoubleToStr(d_B,0);
   Teks=Teks_Menit+":"+Teks_Detik;

   //Price
   double Price1 = iMA(Symbol(),0,1,0,MODE_EMA,PRICE_CLOSE,0);   
    Teks=DoubleToStr(Price1,Digits);

   int R1=0,R5=0,R10=0,R20=0,RAvg=0,i=0;
   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point*0.1;
   for(i=1;i<=5;i++)
      R5    =    R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point*0.1;
   for(i=1;i<=10;i++)
      R10   =    R10 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point*0.1;
   for(i=1;i<=20;i++)
      R20   =    R20 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point*0.1;

   R5 = R5/5;
   R10 = R10/10;
   R20 = R20/20;
   RAvg  =  (R1+R5+R10+R20)/4;    
   
   string HI="",LO="",SPREAD="",PIPS="",DAV="",HILO="",PRC,Pips="",Av="",AV_Yest="";
   string OPEN="";
   color color_pip,color_av;
   double Open_Today = iOpen(NULL,1440,0);
   double CLOSE = iClose(NULL,1440,0);
   double SPRD = (Ask - Bid)/Point;
   double High_Today = iHigh(NULL,1440,0);
   double Low_Today = iLow(NULL,1440,0);
   PIPS =  DoubleToStr((CLOSE-Open_Today)/Point*0.1,0);
   SPREAD = (DoubleToStr(SPRD,Digits-5));
   DAV = (DoubleToStr(RAvg,Digits-5));
   AV_Yest =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
   HILO = DoubleToStr((High_Today-Low_Today)/Point*0.1,0);
   OPEN =  (DoubleToStr(Open_Today,Digits));
   HI =  (DoubleToStr(High_Today,Digits));
   LO =  (DoubleToStr(Low_Today,Digits));
  
     if (CLOSE >= Open_Today) {Pips= "-";color_pip = LimeGreen; }
     if (CLOSE < Open_Today) {Pips= "-";color_pip = DarkOrange; }
     if (DAV > AV_Yest) {Av= "-";color_av = LimeGreen; }
     if (DAV < AV_Yest) {Av= "-";color_av = DarkOrange; }

  //*****************************************************************************************************
   //D1_TREND
   string D1Mid="",D1Pivot="",D1OPEN="";
   color color_d1op;
   double Open_D1 = iOpen(NULL,1440,0);
   D1OPEN =  (DoubleToStr(Open_D1,Digits));
   double D1r = iHigh(NULL,PERIOD_D1,1) - iLow(NULL,PERIOD_D1,1);
   double D1R = (iHigh(NULL,PERIOD_D1,1) + iLow(NULL,PERIOD_D1,1))/2;
   double D1P = (iHigh(NULL,PERIOD_D1,1) + iLow(NULL,PERIOD_D1,1) + iClose(NULL,PERIOD_D1,1))/3;
   D1Mid = DoubleToStr(D1R,Digits);
   D1Pivot = DoubleToStr(D1P,Digits);

     if (D1OPEN > D1Pivot) {color_d1op=LimeGreen;}
     if (D1OPEN < D1Pivot) {color_d1op=Orange;}
     if (D1OPEN == D1Pivot) {color_d1op=DarkGray;}

   //MarketD1
   string SW01="",UP01="",UP02="",UP03="",
          UP04="",UP05="",UP06="",Mid00="",
          TPb1="",TPb2="",TPb3="",TPs1="",TPs2="",TPs3="",
          TP1="",TP2="",TP3="";
   color Midplus_clr,UPtp1D1_clr,UPtp2D1_clr,UPtp3D1_clr,
         UPtp4D1_clr,UPtp5D1_clr,UPtp6D1_clr,TP_clr;

   double Midnol = (Open_D1 + D1P) * 1/2;
   Mid00 = DoubleToStr(Midnol,Digits);

   double UPtp1D1 = D1P + (D1r * 0.236);
   double UPtp2D1 = D1P + (D1r * 0.382);
   double UPtp3D1 = D1P + (D1r * 0.618);
   double UPtp4D1 = D1P + (D1r * 0.764);
   double UPtp5D1 = D1P + (D1r * 1.000);
   double UPtp6D1 = D1P + (D1r * 1.236);
  
   double DNtp1D1 = D1P - (D1r * 0.236);
   double DNtp2D1 = D1P - (D1r * 0.382);
   double DNtp3D1 = D1P - (D1r * 0.618);
   double DNtp4D1 = D1P - (D1r * 0.764);
   double DNtp5D1 = D1P - (D1r * 1.000);
   double DNtp6D1 = D1P - (D1r * 1.236);
  
   TPb1 = DoubleToStr(UPtp2D1,Digits);
   TPb2 = DoubleToStr(UPtp3D1,Digits);
   TPb3 = DoubleToStr(UPtp6D1,Digits);
   TPs1 = DoubleToStr(DNtp2D1,Digits);
   TPs2 = DoubleToStr(DNtp3D1,Digits);
   TPs3 = DoubleToStr(DNtp6D1,Digits);

     if (Price1 > Midnol) {SW01="n"; Midplus_clr=SW2up_clr;}
     if (Price1 < Midnol) {SW01="n"; Midplus_clr=SW2dn_clr;}
     if (Price1 == Midnol) {SW01="n"; Midplus_clr=SW0_clr;}
     if (Teks > Mid00) {TP1=TPb1; TP2=TPb2; TP3=TPb3; TP_clr=UP3_clr;}
     if (Teks < Mid00) {TP1=TPs1; TP2=TPs2; TP3=TPs3; TP_clr=DN3_clr;}
     if (Price1 > UPtp1D1) {UP01="g"; UPtp1D1_clr=UP0_clr;}
     if (Price1 < DNtp1D1) {UP01="g"; UPtp1D1_clr=DN0_clr;}
     if (Price1 > UPtp2D1) {UP02="g"; UPtp2D1_clr=UP1_clr;}
     if (Price1 < DNtp2D1) {UP02="g"; UPtp2D1_clr=DN1_clr;}
     if (Price1 > UPtp3D1) {UP03="g"; UPtp3D1_clr=UP2_clr;}
     if (Price1 < DNtp3D1) {UP03="g"; UPtp3D1_clr=DN2_clr;}
     if (Price1 > UPtp4D1) {UP04="g"; UPtp4D1_clr=UP3_clr;}
     if (Price1 < DNtp4D1) {UP04="g"; UPtp4D1_clr=DN3_clr;}
     if (Price1 > UPtp5D1) {UP05="g"; UPtp5D1_clr=UP4_clr;}
     if (Price1 < DNtp5D1) {UP05="g"; UPtp5D1_clr=DN4_clr;}
     if (Price1 > UPtp6D1) {UP06="g"; UPtp6D1_clr=UP5_clr;}
     if (Price1 < DNtp6D1) {UP06="g"; UPtp6D1_clr=DN5_clr;}

  //*****************************************************************************************************
   //H4_TREND
   string H4Mid="",H4Pivot="",H4OPEN="";
   double Open_H4 = iOpen(NULL,240,0);
   H4OPEN =  (DoubleToStr(Open_H4,Digits));
   double H4r = iHigh(NULL,PERIOD_H4,1) - iLow(NULL,PERIOD_H4,1);
   double H4R = (iHigh(NULL,PERIOD_H4,1) + iLow(NULL,PERIOD_H4,1))/2;
   double H4P = (iHigh(NULL,PERIOD_H4,1) + iLow(NULL,PERIOD_H4,1) + iClose(NULL,PERIOD_H4,1))/3;
   H4Mid = DoubleToStr(H4R,Digits);
   H4Pivot = DoubleToStr(H4P,Digits);

   //MarketH4
   string SW01h4="",UP01h4="",UP02h4="",UP03h4="",
          UP04h4="",UP05h4="",UP06h4="";
   color Midplush4_clr,UPtp1h4_clr,UPtp2h4_clr,UPtp3h4_clr,
         UPtp4h4_clr,UPtp5h4_clr,UPtp6h4_clr;

   double Midnolh4 = (Open_H4 + H4P) * 1/2;

   double UPtp1h4 = H4P + (H4r * 0.236);
   double UPtp2h4 = H4P + (H4r * 0.382);
   double UPtp3h4 = H4P + (H4r * 0.618);
   double UPtp4h4 = H4P + (H4r * 0.764);
   double UPtp5h4 = H4P + (H4r * 1.000);
   double UPtp6h4 = H4P + (H4r * 1.236);
  
   double DNtp1h4 = H4P - (H4r * 0.236);
   double DNtp2h4 = H4P - (H4r * 0.382);
   double DNtp3h4 = H4P - (H4r * 0.618);
   double DNtp4h4 = H4P - (H4r * 0.764);
   double DNtp5h4 = H4P - (H4r * 1.000);
   double DNtp6h4 = H4P - (H4r * 1.236);
  
     if (Price1 > Midnolh4) {SW01h4="n"; Midplush4_clr=SW2up_clr;}
     if (Price1 < Midnolh4) {SW01h4="n"; Midplush4_clr=SW2dn_clr;}
     if (Price1 == Midnolh4) {SW01h4="n"; Midplush4_clr=SW0_clr;}
     if (Price1 > UPtp1h4) {UP01h4="g"; UPtp1h4_clr=UP0_clr;}
     if (Price1 < DNtp1h4) {UP01h4="g"; UPtp1h4_clr=DN0_clr;}
     if (Price1 > UPtp2h4) {UP02h4="g"; UPtp2h4_clr=UP1_clr;}
     if (Price1 < DNtp2h4) {UP02h4="g"; UPtp2h4_clr=DN1_clr;}
     if (Price1 > UPtp3h4) {UP03h4="g"; UPtp3h4_clr=UP2_clr;}
     if (Price1 < DNtp3h4) {UP03h4="g"; UPtp3h4_clr=DN2_clr;}
     if (Price1 > UPtp4h4) {UP04h4="g"; UPtp4h4_clr=UP3_clr;}
     if (Price1 < DNtp4h4) {UP04h4="g"; UPtp4h4_clr=DN3_clr;}
     if (Price1 > UPtp5h4) {UP05h4="g"; UPtp5h4_clr=UP4_clr;}
     if (Price1 < DNtp5h4) {UP05h4="g"; UPtp5h4_clr=DN4_clr;}
     if (Price1 > UPtp6h4) {UP06h4="g"; UPtp6h4_clr=UP5_clr;}
     if (Price1 < DNtp6h4) {UP06h4="g"; UPtp6h4_clr=DN5_clr;}

   //*****************************************************************************************************
   //H1_TREND
   string H1Mid="",H1Pivot="",H1OPEN="";
   double Open_H1 = iOpen(NULL,60,0);
   H1OPEN =  (DoubleToStr(Open_H1,Digits));
   double H1r = iHigh(NULL,PERIOD_H1,1) - iLow(NULL,PERIOD_H1,1);
   double H1R = (iHigh(NULL,PERIOD_H1,1) + iLow(NULL,PERIOD_H1,1))/2;
   double H1P = (iHigh(NULL,PERIOD_H1,1) + iLow(NULL,PERIOD_H1,1) + iClose(NULL,PERIOD_H1,1))/3;
   H1Mid = DoubleToStr(H1R,Digits);
   H1Pivot = DoubleToStr(H1P,Digits);

   //MarketH1
   string SW01h1="",UP01h1="",UP02h1="",UP03h1="",
          UP04h1="",UP05h1="",UP06h1="";
   color Midplush1_clr,UPtp1h1_clr,UPtp2h1_clr,UPtp3h1_clr,
         UPtp4h1_clr,UPtp5h1_clr,UPtp6h1_clr;

   double Midnolh1 = (Open_H1 + H1P) * 1/2;

   double UPtp1h1 = H1P + (H1r * 0.236);
   double UPtp2h1 = H1P + (H1r * 0.382);
   double UPtp3h1 = H1P + (H1r * 0.618);
   double UPtp4h1 = H1P + (H1r * 0.764);
   double UPtp5h1 = H1P + (H1r * 1.000);
   double UPtp6h1 = H1P + (H1r * 1.236);
  
   double DNtp1h1 = H1P - (H1r * 0.236);
   double DNtp2h1 = H1P - (H1r * 0.382);
   double DNtp3h1 = H1P - (H1r * 0.618);
   double DNtp4h1 = H1P - (H1r * 0.764);
   double DNtp5h1 = H1P - (H1r * 1.000);
   double DNtp6h1 = H1P - (H1r * 1.236);
  
     if (Price1 > Midnolh1) {SW01h1="n"; Midplush1_clr=SW2up_clr;}
     if (Price1 < Midnolh1) {SW01h1="n"; Midplush1_clr=SW2dn_clr;}
     if (Price1 == Midnolh1) {SW01h1="n"; Midplush1_clr=SW0_clr;}
     if (Price1 > UPtp1h1) {UP01h1="g"; UPtp1h1_clr=UP0_clr;}
     if (Price1 < DNtp1h1) {UP01h1="g"; UPtp1h1_clr=DN0_clr;}
     if (Price1 > UPtp2h1) {UP02h1="g"; UPtp2h1_clr=UP1_clr;}
     if (Price1 < DNtp2h1) {UP02h1="g"; UPtp2h1_clr=DN1_clr;}
     if (Price1 > UPtp3h1) {UP03h1="g"; UPtp3h1_clr=UP2_clr;}
     if (Price1 < DNtp3h1) {UP03h1="g"; UPtp3h1_clr=DN2_clr;}
     if (Price1 > UPtp4h1) {UP04h1="g"; UPtp4h1_clr=UP3_clr;}
     if (Price1 < DNtp4h1) {UP04h1="g"; UPtp4h1_clr=DN3_clr;}
     if (Price1 > UPtp5h1) {UP05h1="g"; UPtp5h1_clr=UP4_clr;}
     if (Price1 < DNtp5h1) {UP05h1="g"; UPtp5h1_clr=DN4_clr;}
     if (Price1 > UPtp6h1) {UP06h1="g"; UPtp6h1_clr=UP5_clr;}
     if (Price1 < DNtp6h1) {UP06h1="g"; UPtp6h1_clr=DN5_clr;}

   //*****************************************************************************************************
   //M30_TREND
   string M30Mid="",M30Pivot="",M30OPEN="";
   double Open_M30 = iOpen(NULL,30,0);
   M30OPEN =  (DoubleToStr(Open_M30,Digits));
   double M30r = iHigh(NULL,PERIOD_M30,1) - iLow(NULL,PERIOD_M30,1);
   double M30R = (iHigh(NULL,PERIOD_M30,1) + iLow(NULL,PERIOD_M30,1))/2;
   double M30P = (iHigh(NULL,PERIOD_M30,1) + iLow(NULL,PERIOD_M30,1) + iClose(NULL,PERIOD_M30,1))/3;
   M30Mid = DoubleToStr(M30R,Digits);
   M30Pivot = DoubleToStr(M30P,Digits);

   //MarketM30
   string SW01m30="",UP01m30="",UP02m30="",UP03m30="",
          UP04m30="",UP05m30="",UP06m30="";
   color Midplusm30_clr,UPtp1m30_clr,UPtp2m30_clr,UPtp3m30_clr,
         UPtp4m30_clr,UPtp5m30_clr,UPtp6m30_clr;

   double Midnolm30 = (Open_M30 + M30P) * 1/2;

   double UPtp1m30 = M30P + (M30r * 0.236);
   double UPtp2m30 = M30P + (M30r * 0.382);
   double UPtp3m30 = M30P + (M30r * 0.618);
   double UPtp4m30 = M30P + (M30r * 0.764);
   double UPtp5m30 = M30P + (M30r * 1.000);
   double UPtp6m30 = M30P + (M30r * 1.236);
  
   double DNtp1m30 = M30P - (M30r * 0.236);
   double DNtp2m30 = M30P - (M30r * 0.382);
   double DNtp3m30 = M30P - (M30r * 0.618);
   double DNtp4m30 = M30P - (M30r * 0.764);
   double DNtp5m30 = M30P - (M30r * 1.000);
   double DNtp6m30 = M30P - (M30r * 1.236);
  
     if (Price1 > Midnolm30) {SW01m30="n"; Midplusm30_clr=SW2up_clr;}
     if (Price1 < Midnolm30) {SW01m30="n"; Midplusm30_clr=SW2dn_clr;}
     if (Price1 == Midnolm30) {SW01m30="n"; Midplusm30_clr=SW0_clr;}
     if (Price1 > UPtp1m30) {UP01m30="g"; UPtp1m30_clr=UP0_clr;}
     if (Price1 < DNtp1m30) {UP01m30="g"; UPtp1m30_clr=DN0_clr;}
     if (Price1 > UPtp2m30) {UP02m30="g"; UPtp2m30_clr=UP1_clr;}
     if (Price1 < DNtp2m30) {UP02m30="g"; UPtp2m30_clr=DN1_clr;}
     if (Price1 > UPtp3m30) {UP03m30="g"; UPtp3m30_clr=UP2_clr;}
     if (Price1 < DNtp3m30) {UP03m30="g"; UPtp3m30_clr=DN2_clr;}
     if (Price1 > UPtp4m30) {UP04m30="g"; UPtp4m30_clr=UP3_clr;}
     if (Price1 < DNtp4m30) {UP04m30="g"; UPtp4m30_clr=DN3_clr;}
     if (Price1 > UPtp5m30) {UP05m30="g"; UPtp5m30_clr=UP4_clr;}
     if (Price1 < DNtp5m30) {UP05m30="g"; UPtp5m30_clr=DN4_clr;}
     if (Price1 > UPtp6m30) {UP06m30="g"; UPtp6m30_clr=UP5_clr;}
     if (Price1 < DNtp6m30) {UP06m30="g"; UPtp6m30_clr=DN5_clr;}

   //*****************************************************************************************************
   //M15_TREND
   string M15Mid="",M15Pivot="",M15OPEN="";
   double Open_M15 = iOpen(NULL,15,0);
   M15OPEN =  (DoubleToStr(Open_M15,Digits));
   double M15r = iHigh(NULL,PERIOD_M15,1) - iLow(NULL,PERIOD_M15,1);
   double M15R = (iHigh(NULL,PERIOD_M15,1) + iLow(NULL,PERIOD_M15,1))/2;
   double M15P = (iHigh(NULL,PERIOD_M15,1) + iLow(NULL,PERIOD_M15,1) + iClose(NULL,PERIOD_M15,1))/3;
   M15Mid = DoubleToStr(M15R,Digits);
   M15Pivot = DoubleToStr(M15P,Digits);

   //MarketM15
   string SW01m15="",UP01m15="",UP02m15="",UP03m15="",
          UP04m15="",UP05m15="",UP06m15="";
   color Midplusm15_clr,UPtp1m15_clr,UPtp2m15_clr,UPtp3m15_clr,
         UPtp4m15_clr,UPtp5m15_clr,UPtp6m15_clr;

   double Midnolm15 = (Open_M15 + M15P) * 1/2;

   double UPtp1m15 = M15P + (M15r * 0.236);
   double UPtp2m15 = M15P + (M15r * 0.382);
   double UPtp3m15 = M15P + (M15r * 0.618);
   double UPtp4m15 = M15P + (M15r * 0.764);
   double UPtp5m15 = M15P + (M15r * 1.000);
   double UPtp6m15 = M15P + (M15r * 1.236);
  
   double DNtp1m15 = M15P - (M15r * 0.236);
   double DNtp2m15 = M15P - (M15r * 0.382);
   double DNtp3m15 = M15P - (M15r * 0.618);
   double DNtp4m15 = M15P - (M15r * 0.764);
   double DNtp5m15 = M15P - (M15r * 1.000);
   double DNtp6m15 = M15P - (M15r * 1.236);
  
     if (Price1 > Midnolm15) {SW01m15="n"; Midplusm15_clr=SW2up_clr;}
     if (Price1 < Midnolm15) {SW01m15="n"; Midplusm15_clr=SW2dn_clr;}
     if (Price1 == Midnolm15) {SW01m15="n"; Midplusm15_clr=SW0_clr;}
     if (Price1 > UPtp1m15) {UP01m15="g"; UPtp1m15_clr=UP0_clr;}
     if (Price1 < DNtp1m15) {UP01m15="g"; UPtp1m15_clr=DN0_clr;}
     if (Price1 > UPtp2m15) {UP02m15="g"; UPtp2m15_clr=UP1_clr;}
     if (Price1 < DNtp2m15) {UP02m15="g"; UPtp2m15_clr=DN1_clr;}
     if (Price1 > UPtp3m15) {UP03m15="g"; UPtp3m15_clr=UP2_clr;}
     if (Price1 < DNtp3m15) {UP03m15="g"; UPtp3m15_clr=DN2_clr;}
     if (Price1 > UPtp4m15) {UP04m15="g"; UPtp4m15_clr=UP3_clr;}
     if (Price1 < DNtp4m15) {UP04m15="g"; UPtp4m15_clr=DN3_clr;}
     if (Price1 > UPtp5m15) {UP05m15="g"; UPtp5m15_clr=UP4_clr;}
     if (Price1 < DNtp5m15) {UP05m15="g"; UPtp5m15_clr=DN4_clr;}
     if (Price1 > UPtp6m15) {UP06m15="g"; UPtp6m15_clr=UP5_clr;}
     if (Price1 < DNtp6m15) {UP06m15="g"; UPtp6m15_clr=DN5_clr;}

   //*****************************************************************************************************
   //M5_TREND
   string M5Mid="",M5Pivot="",M5OPEN="";
   double Open_M5 = iOpen(NULL,5,0);
   M5OPEN =  (DoubleToStr(Open_M5,Digits));
   double M5r = iHigh(NULL,PERIOD_M5,1) - iLow(NULL,PERIOD_M5,1);
   double M5R = (iHigh(NULL,PERIOD_M5,1) + iLow(NULL,PERIOD_M5,1))/2;
   double M5P = (iHigh(NULL,PERIOD_M5,1) + iLow(NULL,PERIOD_M5,1) + iClose(NULL,PERIOD_M5,1))/3;
   M5Mid = DoubleToStr(M5R,Digits);
   M5Pivot = DoubleToStr(M5P,Digits);

   //MarketM5
   string SW01m5="",UP01m5="",UP02m5="",UP03m5="",
          UP04m5="",UP05m5="",UP06m5="";
   color Midplusm5_clr,UPtp1m5_clr,UPtp2m5_clr,UPtp3m5_clr,
         UPtp4m5_clr,UPtp5m5_clr,UPtp6m5_clr;

   double Midnolm5 = (Open_M5 + M5P) * 1/2;

   double UPtp1m5 = M5P + (M5r * 0.236);
   double UPtp2m5 = M5P + (M5r * 0.382);
   double UPtp3m5 = M5P + (M5r * 0.618);
   double UPtp4m5 = M5P + (M5r * 0.764);
   double UPtp5m5 = M5P + (M5r * 1.000);
   double UPtp6m5 = M5P + (M5r * 1.236);
  
   double DNtp1m5 = M5P - (M5r * 0.236);
   double DNtp2m5 = M5P - (M5r * 0.382);
   double DNtp3m5 = M5P - (M5r * 0.618);
   double DNtp4m5 = M5P - (M5r * 0.764);
   double DNtp5m5 = M5P - (M5r * 1.000);
   double DNtp6m5 = M5P - (M5r * 1.236);
  
     if (Price1 > Midnolm5) {SW01m5="n"; Midplusm5_clr=SW2up_clr;}
     if (Price1 < Midnolm5) {SW01m5="n"; Midplusm5_clr=SW2dn_clr;}
     if (Price1 == Midnolm5) {SW01m5="n"; Midplusm5_clr=SW0_clr;}
     if (Price1 > UPtp1m5) {UP01m5="g"; UPtp1m5_clr=UP0_clr;}
     if (Price1 < DNtp1m5) {UP01m5="g"; UPtp1m5_clr=DN0_clr;}
     if (Price1 > UPtp2m5) {UP02m5="g"; UPtp2m5_clr=UP1_clr;}
     if (Price1 < DNtp2m5) {UP02m5="g"; UPtp2m5_clr=DN1_clr;}
     if (Price1 > UPtp3m5) {UP03m5="g"; UPtp3m5_clr=UP2_clr;}
     if (Price1 < DNtp3m5) {UP03m5="g"; UPtp3m5_clr=DN2_clr;}
     if (Price1 > UPtp4m5) {UP04m5="g"; UPtp4m5_clr=UP3_clr;}
     if (Price1 < DNtp4m5) {UP04m5="g"; UPtp4m5_clr=DN3_clr;}
     if (Price1 > UPtp5m5) {UP05m5="g"; UPtp5m5_clr=UP4_clr;}
     if (Price1 < DNtp5m5) {UP05m5="g"; UPtp5m5_clr=DN4_clr;}
     if (Price1 > UPtp6m5) {UP06m5="g"; UPtp6m5_clr=UP5_clr;}
     if (Price1 < DNtp6m5) {UP06m5="g"; UPtp6m5_clr=DN5_clr;}

   //*****************************************************************************************************
   //M1_TREND
   string M1Mid="",M1Pivot="",M1OPEN="";
   double Open_M1 = iOpen(NULL,1,0);
   M1OPEN =  (DoubleToStr(Open_M1,Digits));
   double M1r = iHigh(NULL,PERIOD_M1,1) - iLow(NULL,PERIOD_M1,1);
   double M1R = (iHigh(NULL,PERIOD_M1,1) + iLow(NULL,PERIOD_M1,1))/2;
   double M1P = (iHigh(NULL,PERIOD_M1,1) + iLow(NULL,PERIOD_M1,1) + iClose(NULL,PERIOD_M1,1))/3;
   M1Mid = DoubleToStr(M1R,Digits);
   M1Pivot = DoubleToStr(M1P,Digits);

   //MarketM1
   string SW01m1="",UP01m1="",UP02m1="",UP03m1="",
          UP04m1="",UP05m1="",UP06m1="";
   color Midplusm1_clr,UPtp1m1_clr,UPtp2m1_clr,UPtp3m1_clr,
         UPtp4m1_clr,UPtp5m1_clr,UPtp6m1_clr;

   double Midnolm1 = (Open_M1 + M1P) * 1/2;

   double UPtp1m1 = M1P + (M1r * 0.236);
   double UPtp2m1 = M1P + (M1r * 0.382);
   double UPtp3m1 = M1P + (M1r * 0.618);
   double UPtp4m1 = M1P + (M1r * 0.764);
   double UPtp5m1 = M1P + (M1r * 1.000);
   double UPtp6m1 = M1P + (M1r * 1.236);
  
   double DNtp1m1 = M1P - (M1r * 0.236);
   double DNtp2m1 = M1P - (M1r * 0.382);
   double DNtp3m1 = M1P - (M1r * 0.618);
   double DNtp4m1 = M1P - (M1r * 0.764);
   double DNtp5m1 = M1P - (M1r * 1.000);
   double DNtp6m1 = M1P - (M1r * 1.236);
  
     if (Price1 > Midnolm1) {SW01m1="n"; Midplusm1_clr=SW2up_clr;}
     if (Price1 < Midnolm1) {SW01m1="n"; Midplusm1_clr=SW2dn_clr;}
     if (Price1 == Midnolm1) {SW01m1="n"; Midplusm1_clr=SW0_clr;}
     if (Price1 > UPtp1m1) {UP01m1="g"; UPtp1m1_clr=UP0_clr;}
     if (Price1 < DNtp1m1) {UP01m1="g"; UPtp1m1_clr=DN0_clr;}
     if (Price1 > UPtp2m1) {UP02m1="g"; UPtp2m1_clr=UP1_clr;}
     if (Price1 < DNtp2m1) {UP02m1="g"; UPtp2m1_clr=DN1_clr;}
     if (Price1 > UPtp3m1) {UP03m1="g"; UPtp3m1_clr=UP2_clr;}
     if (Price1 < DNtp3m1) {UP03m1="g"; UPtp3m1_clr=DN2_clr;}
     if (Price1 > UPtp4m1) {UP04m1="g"; UPtp4m1_clr=UP3_clr;}
     if (Price1 < DNtp4m1) {UP04m1="g"; UPtp4m1_clr=DN3_clr;}
     if (Price1 > UPtp5m1) {UP05m1="g"; UPtp5m1_clr=UP4_clr;}
     if (Price1 < DNtp5m1) {UP05m1="g"; UPtp5m1_clr=DN4_clr;}
     if (Price1 > UPtp6m1) {UP06m1="g"; UPtp6m1_clr=UP5_clr;}
     if (Price1 < DNtp6m1) {UP06m1="g"; UPtp6m1_clr=DN5_clr;}

   //******************************************************************************************************************
   string jogetS1="", jogetS2="", jogetT="";
   color clr_jogetS1, clr_jogetS2, clr_jogetT;

     if ((Teks > M1OPEN) && (Teks > M5OPEN) && (Teks > M1Pivot) && (Teks > M5Pivot))
        {jogetS1="UP"; clr_jogetS1=UP_clr;}
     else if ((Teks < M1Pivot) && (Teks < M5Pivot) && (Teks < M1OPEN) && (Teks < M5OPEN))
             {jogetS1="DN"; clr_jogetS1=DN_clr;}
          else {jogetS1="-----"; clr_jogetS1=SW_clr;}

     if ((Teks > M15OPEN) && (Teks > M30OPEN) && (Teks > H1OPEN)
        && (Teks > M15Pivot) && (Teks > M30Pivot) && (Teks > H1Pivot))
        {jogetS2="UP"; clr_jogetS2=UP_clr;}
     else if ((Teks < M15Pivot) && (Teks < M30Pivot) && (Teks < H1Pivot)
             && (Teks < M15OPEN) && (Teks < M30OPEN) && (Teks < H1OPEN))
             {jogetS2="DN"; clr_jogetS2=DN_clr;}
          else {jogetS2="-----"; clr_jogetS2=SW_clr;}

     if ((Teks > H4OPEN) && (Teks > D1OPEN) && (Teks > H4Pivot) && (Teks > D1Pivot))
        {jogetT="UP"; clr_jogetT=UP_clr;}
     else if ((Teks < H4Pivot) && (Teks < D1Pivot) && (Teks < H4OPEN) && (Teks < D1OPEN))
             {jogetT="DN"; clr_jogetT=DN_clr;}
          else {jogetT="-----"; clr_jogetT=SW_clr;}


   ObjectSetText("joFast", "Fast", 10, "Arial Bold", clr_jogetS1);
   ObjectSetText("joSignal", "Signal", 10, "Arial Bold", clr_jogetS2);
   ObjectSetText("joTrend", "Trend", 10, "Arial Bold", clr_jogetT);

   //******************************************************************************************************************
   string jogetM1="", jogetM5="", jogetM15="", jogetM30="", jogetH1="", jogetH4="", jogetD1="";
   color clr_jogetM1, clr_jogetM5, clr_jogetM15, clr_jogetM30, clr_jogetH1, clr_jogetH4, clr_jogetD1;

     if ((Teks > M1OPEN) && (Teks > M1Pivot))
        {jogetM1="g"; clr_jogetM1=UP_clr;}
     else if ((Teks < M1Pivot) && (Teks < M1OPEN))
             {jogetM1="g"; clr_jogetM1=DN_clr;}
          else {jogetM1="g"; clr_jogetM1=SW_clr;}

     if ((Teks > M5OPEN) && (Teks > M5Pivot))
        {jogetM5="g"; clr_jogetM5=UP_clr;}
     else if ((Teks < M5Pivot) && (Teks < M5OPEN))
             {jogetM5="g"; clr_jogetM5=DN_clr;}
          else {jogetM5="g"; clr_jogetM5=SW_clr;}

     if ((Teks > M15OPEN) && (Teks > M15Pivot))
        {jogetM15="g"; clr_jogetM15=UP_clr;}
     else if ((Teks < M15Pivot) && (Teks < M15OPEN))
             {jogetM15="g"; clr_jogetM15=DN_clr;}
          else {jogetM15="g"; clr_jogetM15=SW_clr;}

     if ((Teks > M30OPEN) && (Teks > M30Pivot))
        {jogetM30="g"; clr_jogetM30=UP_clr;}
     else if ((Teks < M30Pivot) && (Teks < M30OPEN))
             {jogetM30="g"; clr_jogetM30=DN_clr;}
          else {jogetM30="g"; clr_jogetM30=SW_clr;}

     if ((Teks > H1OPEN) && (Teks > H1Pivot))
        {jogetH1="g"; clr_jogetH1=UP_clr;}
     else if ((Teks < H1Pivot) && (Teks < H1OPEN))
             {jogetH1="g"; clr_jogetH1=DN_clr;}
          else {jogetH1="g"; clr_jogetH1=SW_clr;}

     if ((Teks > H4OPEN) && (Teks > H4Pivot))
        {jogetH4="g"; clr_jogetH4=UP_clr;}
     else if ((Teks < H4Pivot) && (Teks < H4OPEN))
             {jogetH4="g"; clr_jogetH4=DN_clr;}
          else {jogetH4="g"; clr_jogetH4=SW_clr;}

     if ((Teks > D1OPEN) && (Teks > D1Pivot))
        {jogetD1="g"; clr_jogetD1=UP_clr;}
     else if ((Teks < D1Pivot) && (Teks < D1OPEN))
             {jogetD1="g"; clr_jogetD1=DN_clr;}
          else {jogetD1="g"; clr_jogetD1=SW_clr;}

   ObjectSetText("joSignalM1", jogetM1, 12, "Webdings", clr_jogetM1);
   ObjectSetText("joSignalM5", jogetM5, 12, "Webdings", clr_jogetM5);
   ObjectSetText("joSignalM15", jogetM15, 12, "Webdings", clr_jogetM15);
   ObjectSetText("joSignalM30", jogetM30, 12, "Webdings", clr_jogetM30);
   ObjectSetText("joSignalH1", jogetH1, 12, "Webdings", clr_jogetH1);
   ObjectSetText("joSignalH4", jogetH4, 12, "Webdings", clr_jogetH4);
   ObjectSetText("joSignalD1", jogetD1, 12, "Webdings", clr_jogetD1);
  
//*****************************************************************************************************
   double S_cM1=iMA(NULL,1,FastMA,0,MA_Mode,MA_PriceType,0)-iMA(NULL,1,SlowMA,0,MA_Mode,MA_PriceType,0);
   double S_cM5=iMA(NULL,5,FastMA,0,MA_Mode,MA_PriceType,0)-iMA(NULL,5,SlowMA,0,MA_Mode,MA_PriceType,0);
   double S_cM15=iMA(NULL,15,FastMA,0,MA_Mode,MA_PriceType,0)-iMA(NULL,15,SlowMA,0,MA_Mode,MA_PriceType,0);
   double S_cM30=iMA(NULL,30,FastMA,0,MA_Mode,MA_PriceType,0)-iMA(NULL,30,SlowMA,0,MA_Mode,MA_PriceType,0);
   double S_cH1=iMA(NULL,60,FastMA,0,MA_Mode,MA_PriceType,0)-iMA(NULL,60,SlowMA,0,MA_Mode,MA_PriceType,0);
   double S_cH4=iMA(NULL,240,FastMA,0,MA_Mode,MA_PriceType,0)-iMA(NULL,240,SlowMA,0,MA_Mode,MA_PriceType,0);
   double S_cD1=iMA(NULL,1440,FastMA,0,MA_Mode,MA_PriceType,0)-iMA(NULL,1440,SlowMA,0,MA_Mode,MA_PriceType,0);
   
   double S_pM1=iMA(NULL,1,FastMA,0,MA_Mode,MA_PriceType,1)-iMA(NULL,1,SlowMA,0,MA_Mode,MA_PriceType,1);
   double S_pM5=iMA(NULL,5,FastMA,0,MA_Mode,MA_PriceType,1)-iMA(NULL,5,SlowMA,0,MA_Mode,MA_PriceType,1);
   double S_pM15=iMA(NULL,15,FastMA,0,MA_Mode,MA_PriceType,1)-iMA(NULL,15,SlowMA,0,MA_Mode,MA_PriceType,1);
   double S_pM30=iMA(NULL,30,FastMA,0,MA_Mode,MA_PriceType,1)-iMA(NULL,30,SlowMA,0,MA_Mode,MA_PriceType,1);
   double S_pH1=iMA(NULL,60,FastMA,0,MA_Mode,MA_PriceType,1)-iMA(NULL,60,SlowMA,0,MA_Mode,MA_PriceType,1);
   double S_pH4=iMA(NULL,240,FastMA,0,MA_Mode,MA_PriceType,1)-iMA(NULL,240,SlowMA,0,MA_Mode,MA_PriceType,1);
   double S_pD1=iMA(NULL,1440,FastMA,0,MA_Mode,MA_PriceType,1)-iMA(NULL,1440,SlowMA,0,MA_Mode,MA_PriceType,1);
   
   double avg_M1 = iMAOnArray(S_cM1, 0, BBperiode, 0, MA_Mode, 0);
   double avg_M5 = iMAOnArray(S_cM5, 0, BBperiode, 0, MA_Mode, 0);
   double avg_M15 = iMAOnArray(S_cM15, 0, BBperiode, 0, MA_Mode, 0);
   double avg_M30 = iMAOnArray(S_cM30, 0, BBperiode, 0, MA_Mode, 0);
   double avg_H1 = iMAOnArray(S_cH1, 0, BBperiode, 0, MA_Mode, 0);
   double avg_H4 = iMAOnArray(S_cH4, 0, BBperiode, 0, MA_Mode, 0);
   double avg_D1 = iMAOnArray(S_cD1, 0, BBperiode, 0, MA_Mode, 0);

   double sDev_M1 = iStdDevOnArray(S_cM1, 0, BBperiode, 0, MA_Mode, 0);
   double sDev_M5 = iStdDevOnArray(S_cM5, 0, BBperiode, 0, MA_Mode, 0);
   double sDev_M15 = iStdDevOnArray(S_cM15, 0, BBperiode, 0, MA_Mode, 0);
   double sDev_M30 = iStdDevOnArray(S_cM30, 0, BBperiode, 0, MA_Mode, 0);
   double sDev_H1 = iStdDevOnArray(S_cH1, 0, BBperiode, 0, MA_Mode, 0);
   double sDev_H4 = iStdDevOnArray(S_cH4, 0, BBperiode, 0, MA_Mode, 0);
   double sDev_D1 = iStdDevOnArray(S_cD1, 0, BBperiode, 0, MA_Mode, 0);

   string S_m1 = "", S_m5 = "", S_m15 = "", S_m30 = "", S_h1 = "", S_h4 = "", S_d1 = "",
          T_m1 = "", T_m5 = "", T_m15 = "", T_m30 = "", T_h1 = "", T_h4 = "", T_d1 = "",
          V_m1 = "", V_m5 = "", V_m15 = "", V_m30 = "", V_h1 = "", V_h4 = "", V_d1 = "",
          upBB_m1 = "", upBB_m5 = "", upBB_m15 = "", upBB_m30 = "", upBB_h1 = "", upBB_h4 = "", upBB_d1 = "",
          loBB_m1 = "", loBB_m5 = "", loBB_m15 = "", loBB_m30 = "", loBB_h1 = "", loBB_h4 = "", loBB_d1 = "",
          midBB_m1 = "", midBB_m5 = "", midBB_m15 = "", midBB_m30 = "", midBB_h1 = "", midBB_h4 = "", midBB_d1 = "",
          BS_m1 = "", BS_m5 = "", BS_m15 = "", BS_m30 = "", BS_h1 = "", BS_h4 = "", BS_d1 = "";
   color  Sclr_m1, Sclr_m5, Sclr_m15, Sclr_m30, Sclr_h1, Sclr_h4, Sclr_d1,
          Tclr_m1, Tclr_m5, Tclr_m15, Tclr_m30, Tclr_h1, Tclr_h4, Tclr_d1,
          BSclr_m1, BSclr_m5, BSclr_m15, BSclr_m30, BSclr_h1, BSclr_h4, BSclr_d1;
   
   V_m1 = DoubleToStr(S_cM1,Digits+1);
   V_m5 = DoubleToStr(S_cM5,Digits+1);
   V_m15 = DoubleToStr(S_cM15,Digits+1);
   V_m30 = DoubleToStr(S_cM30,Digits+1);
   V_h1 = DoubleToStr(S_cH1,Digits+1);
   V_h4 = DoubleToStr(S_cH4,Digits+1);
   V_d1 = DoubleToStr(S_cD1,Digits+1);

   upBB_m1 = DoubleToStr((avg_M1 + (StDv * sDev_M1)), Digits+1);  // Upperband 
   upBB_m5 = DoubleToStr((avg_M5 + (StDv * sDev_M5)), Digits+1);  // Upperband 
   upBB_m15 = DoubleToStr((avg_M15 + (StDv * sDev_M15)), Digits+1);  // Upperband 
   upBB_m30 = DoubleToStr((avg_M30 + (StDv * sDev_M30)), Digits+1);  // Upperband 
   upBB_h1 = DoubleToStr((avg_H1 + (StDv * sDev_H1)), Digits+1);  // Upperband 
   upBB_h4 = DoubleToStr((avg_H4 + (StDv * sDev_H4)), Digits+1);  // Upperband 
   upBB_d1 = DoubleToStr((avg_D1 + (StDv * sDev_D1)), Digits+1);  // Upperband 

   loBB_m1 = DoubleToStr((avg_M1 - (StDv * sDev_M1)), Digits+1);  // Lowerband
   loBB_m5 = DoubleToStr((avg_M5 - (StDv * sDev_M5)), Digits+1);  // Lowerband
   loBB_m15 = DoubleToStr((avg_M15 - (StDv * sDev_M15)), Digits+1);  // Lowerband
   loBB_m30 = DoubleToStr((avg_M30 - (StDv * sDev_M30)), Digits+1);  // Lowerband
   loBB_h1 = DoubleToStr((avg_H1 - (StDv * sDev_H1)), Digits+1);  // Lowerband
   loBB_h4 = DoubleToStr((avg_H4 - (StDv * sDev_H4)), Digits+1);  // Lowerband
   loBB_d1 = DoubleToStr((avg_D1 - (StDv * sDev_D1)), Digits+1);  // Lowerband

   midBB_m1 = DoubleToStr(avg_M1, Digits+1) ;  // Midleband
   midBB_m5 = DoubleToStr(avg_M5, Digits+1) ;  // Midleband
   midBB_m15 = DoubleToStr(avg_M15, Digits+1) ;  // Midleband
   midBB_m30 = DoubleToStr(avg_M30, Digits+1) ;  // Midleband
   midBB_h1 = DoubleToStr(avg_H1, Digits+1) ;  // Midleband
   midBB_h4 = DoubleToStr(avg_H4, Digits+1) ;  // Midleband
   midBB_d1 = DoubleToStr(avg_D1, Digits+1) ;  // Midleband

   if (S_cM1 < S_pM1) { S_m1 = "n"; Sclr_m1 = tDN_clr; }
   else if (S_cM1 > S_pM1) { S_m1 = "n"; Sclr_m1 = tUP_clr; }
        else { S_m1 = "n"; Sclr_m1 = tSW_clr; }
   if (S_cM1 < 0) { T_m1 = "n"; Tclr_m1 = DN_clr; }
   else if (S_cM1 > 0) { T_m1 = "n"; Tclr_m1 = UP_clr; }
        else { T_m1 = "n"; Tclr_m1 = SW_clr; }

   if (S_cM5 < S_pM5) { S_m5 = "n"; Sclr_m5 = tDN_clr; }
   else if (S_cM5 > S_pM5) { S_m5 = "n"; Sclr_m5 = tUP_clr; }
        else { S_m5 = "n"; Sclr_m5 = tSW_clr; }
   if (S_cM5 < 0) { T_m5 = "n"; Tclr_m5 = DN_clr; }
   else if (S_cM5 > 0) { T_m5 = "n"; Tclr_m5 = UP_clr; }
        else { T_m5 = "n"; Tclr_m5 = SW_clr; }
   
   if (S_cM15 < S_pM15) { S_m15 = "n"; Sclr_m15 = tDN_clr; }
   else if (S_cM15 > S_pM15) { S_m15 = "n"; Sclr_m15 = tUP_clr; }
        else { S_m15 = "n"; Sclr_m15 = tSW_clr; }
   if (S_cM15 < 0) { T_m15 = "n"; Tclr_m15 = DN_clr; }
   else if (S_cM15 > 0) { T_m15 = "n"; Tclr_m15 = UP_clr; }
        else { T_m15 = "n"; Tclr_m15 = SW_clr; }
      
   if (S_cM30 < S_pM30) { S_m30 = "n"; Sclr_m30 = tDN_clr; }
   else if (S_cM30 > S_pM30) { S_m30 = "n"; Sclr_m30 = tUP_clr; }
        else { S_m30 = "n"; Sclr_m30 = tSW_clr; }
   if (S_cM30 < 0) { T_m30 = "n"; Tclr_m30 = DN_clr; }
   else if (S_cM30 > 0) { T_m30 = "n"; Tclr_m30 = UP_clr; }
        else { T_m30 = "n"; Tclr_m30 = SW_clr; }
   
   if (S_cH1 < S_pH1) { S_h1 = "n"; Sclr_h1 = tDN_clr; }
   else if (S_cH1 > S_pH1) { S_h1 = "n"; Sclr_h1 = tUP_clr; }
        else { S_h1 = "n"; Sclr_h1 = tSW_clr; }
   if (S_cH1 < 0) { T_h1 = "n"; Tclr_h1 = DN_clr; }
   else if (S_cH1 > 0) { T_h1 = "n"; Tclr_h1 = UP_clr; }
        else { T_h1 = "n"; Tclr_h1 = SW_clr; }
   
   if (S_cH4 < S_pH4) { S_h4 = "n"; Sclr_h4 = tDN_clr; }
   else if (S_cH4 > S_pH4) { S_h4 = "n"; Sclr_h4 = tUP_clr; }
        else { S_h4 = "n"; Sclr_h4 = tSW_clr; }
   if (S_cH4 < 0) { T_h4 = "n"; Tclr_h4 = DN_clr; }
   else if (S_cH4 > 0) { T_h4 = "n"; Tclr_h4 = UP_clr; }
        else { T_h4 = "n"; Tclr_h4 = SW_clr; }

   if (S_cD1 < S_pD1) { S_d1 = "n"; Sclr_d1 = tDN_clr; }
   else if (S_cD1 > S_pD1) { S_d1 = "n"; Sclr_d1 = tUP_clr; }
        else { S_d1 = "n"; Sclr_d1 = tSW_clr; }
   if (S_cD1 < 0) { T_d1 = "n"; Tclr_d1 = DN_clr; }
   else if (S_cD1 > 0) { T_d1 = "n"; Tclr_d1 = UP_clr; }
        else { T_d1 = "n"; Tclr_d1 = SW_clr; }

   if ((S_cM1 < S_pM1)&&(V_m1 < loBB_m1)) { BS_m1 = "n"; BSclr_m1 = tDN_clr; }
   else if ((S_cM1 > S_pM1)&&(V_m1 > upBB_m1)) { BS_m1 = "n"; BSclr_m1 = tUP_clr; }
        else { BS_m1 = "n"; BSclr_m1 = tSW_clr; }
   
   if ((S_cM5 < S_pM5)&&(V_m5 < loBB_m5)) { BS_m5 = "n"; BSclr_m5 = tDN_clr; }
   else if ((S_cM5 > S_pM5)&&(V_m5 > upBB_m5)) { BS_m5 = "n"; BSclr_m5 = tUP_clr; }
        else { BS_m5 = "n"; BSclr_m5 = tSW_clr; }
   
   if ((S_cM15 < S_pM15)&&(V_m15 < loBB_m15)) { BS_m15 = "n"; BSclr_m15 = tDN_clr; }
   else if ((S_cM15 > S_pM15)&&(V_m15 > upBB_m15)) { BS_m15 = "n"; BSclr_m15 = tUP_clr; }
        else { BS_m15 = "n"; BSclr_m15 = tSW_clr; }
   
   if ((S_cM30 < S_pM30)&&(V_m30 < loBB_m30)) { BS_m30 = "n"; BSclr_m30 = tDN_clr; }
   else if ((S_cM30 > S_pM30)&&(V_m30 > upBB_m30)) { BS_m30 = "n"; BSclr_m30 = tUP_clr; }
        else { BS_m30 = "n"; BSclr_m30 = tSW_clr; }
   
   if ((S_cH1 < S_pH1)&&(V_h1 < loBB_h1)) { BS_h1 = "n"; BSclr_h1 = tDN_clr; }
   else if ((S_cH1 > S_pH1)&&(V_h1 > upBB_h1)) { BS_h1 = "n"; BSclr_h1 = tUP_clr; }
        else { BS_h1 = "n"; BSclr_h1 = tSW_clr; }
   
   if ((S_cH4 < S_pH4)&&(V_h4 < midBB_h4)) { BS_h4 = "n"; BSclr_h4 = tDN_clr; }
   else if ((S_cH4 > S_pH4)&&(V_h4 > midBB_h4)) { BS_h4 = "n"; BSclr_h4 = tUP_clr; }
        else { BS_h4 = "n"; BSclr_h4 = tSW_clr; }
   
   if ((S_cD1 < S_pD1)&&(V_d1 < midBB_d1)) { BS_d1 = "n"; BSclr_d1 = tDN_clr; }
   else if ((S_cD1 > S_pD1)&&(V_d1 > midBB_d1)) { BS_d1 = "n"; BSclr_d1 = tUP_clr; }
        else { BS_d1 = "n"; BSclr_d1 = tSW_clr; }
   
//*****************************************************************************************************
   ObjectSetText("jobbaoTM1", T_m1, 7, "Webdings", Tclr_m1);
   ObjectSetText("jobbaoTM5", T_m5, 7, "Webdings", Tclr_m5);
   ObjectSetText("jobbaoTM15", T_m15, 7, "Webdings", Tclr_m15);
   ObjectSetText("jobbaoTM30", T_m30, 7, "Webdings", Tclr_m30);
   ObjectSetText("jobbaoTH1", T_h1, 7, "Webdings", Tclr_h1);
   ObjectSetText("jobbaoTH4", T_h4, 7, "Webdings", Tclr_h4);
   ObjectSetText("jobbaoTD1", T_d1, 7, "Webdings", Tclr_d1);

   ObjectSetText("jobbaoBSM1", BS_m1, 12, "Webdings", BSclr_m1);
   ObjectSetText("jobbaoBSM5", BS_m5, 12, "Webdings", BSclr_m5);
   ObjectSetText("jobbaoBSM15", BS_m15, 12, "Webdings", BSclr_m15);
   ObjectSetText("jobbaoBSM30", BS_m30, 12, "Webdings", BSclr_m30);
   ObjectSetText("jobbaoBSH1", BS_h1, 12, "Webdings", BSclr_h1);
   ObjectSetText("jobbaoBSH4", BS_h4, 12, "Webdings", BSclr_h4);
   ObjectSetText("jobbaoBSD1", BS_d1, 12, "Webdings", BSclr_d1);

   ObjectSetText("joTex1", "1", 10, "Arial Black", Sclr_m1);
   ObjectSetText("joTex2", "2", 10, "Arial Black", Sclr_m5);
   ObjectSetText("joTex3", "3", 10, "Arial Black", Sclr_m15);
   ObjectSetText("joTex4", "4", 10, "Arial Black", Sclr_m30);
   ObjectSetText("joTex5", "5", 10, "Arial Black", Sclr_h1);
   ObjectSetText("joTex6", "6", 10, "Arial Black", Sclr_h4);
   ObjectSetText("joTex7", "7", 10, "Arial Black", Sclr_d1);

//*****************************************************************************************************
   ObjectSetText("xCandle", Teks_Menit+":"+Teks_Detik, 10, "Arial Bold", Time_clr);
   ObjectSetText("pric3",""+Teks+"", 18, "Impact",  clr_jogetS2);
   ObjectSetText("joOPD1t", "OPEN", 7, "Arial Bold", Text_clr);
   ObjectSetText("joOPD1a", D1OPEN, 9, "Arial Bold", color_d1op);
   ObjectSetText("joPVD1t", "PIVOT", 7, "Arial Bold", Text_clr);
   ObjectSetText("joPVD1a", D1Pivot, 9, "Arial Bold", Time_clr);
   ObjectSetText("joP2Opent","P2Op", 7, "Arial Bold",  Text_clr);
   ObjectSetText("joP2Opena",""+PIPS+"", 9, "Arial Bold",  color_pip);
   ObjectSetText("joHILOt","HiLo", 7, "Arial Bold",  Text_clr);
   ObjectSetText("joHILOa",""+HILO+"", 9, "Arial Bold",  Spread_clr);
   ObjectSetText("joDAVt","D.Avg", 7, "Arial Bold",  Text_clr);
   ObjectSetText("joDAVa",""+DAV+"", 9, "Arial Bold",  color_av);
   ObjectSetText("joSpreadt","Sprd", 7, "Arial Bold",  Text_clr);
   ObjectSetText("joSpreada",""+SPREAD+"", 9, "Arial Bold",  Spread_clr);
   ObjectSetText("joPair", Symbol(), 12, "Impact",  clr_jogetT);

//*****************************************************************************************************
   ObjectSetText("joG07", SW01, 7, "Webdings", Midplus_clr);
   ObjectSetText("joG06", UP01, 7, "Webdings", UPtp1D1_clr);
   ObjectSetText("joG05", UP02, 7, "Webdings", UPtp2D1_clr);
   ObjectSetText("joG04", UP03, 7, "Webdings", UPtp3D1_clr);
   ObjectSetText("joG03", UP04, 7, "Webdings", UPtp4D1_clr);
   ObjectSetText("joG02", UP05, 7, "Webdings", UPtp5D1_clr);
   ObjectSetText("joG01", UP06, 7, "Webdings", UPtp6D1_clr);

   ObjectSetText("joG014", SW01h4, 7, "Webdings", Midplush4_clr);
   ObjectSetText("joG013", UP01h4, 7, "Webdings", UPtp1h4_clr);
   ObjectSetText("joG012", UP02h4, 7, "Webdings", UPtp2h4_clr);
   ObjectSetText("joG011", UP03h4, 7, "Webdings", UPtp3h4_clr);
   ObjectSetText("joG010", UP04h4, 7, "Webdings", UPtp4h4_clr);
   ObjectSetText("joG09", UP05h4, 7, "Webdings", UPtp5h4_clr);
   ObjectSetText("joG08", UP06h4, 7, "Webdings", UPtp6h4_clr);

   ObjectSetText("joG021", SW01h1, 7, "Webdings", Midplush1_clr);
   ObjectSetText("joG020", UP01h1, 7, "Webdings", UPtp1h1_clr);
   ObjectSetText("joG019", UP02h1, 7, "Webdings", UPtp2h1_clr);
   ObjectSetText("joG018", UP03h1, 7, "Webdings", UPtp3h1_clr);
   ObjectSetText("joG017", UP04h1, 7, "Webdings", UPtp4h1_clr);
   ObjectSetText("joG016", UP05h1, 7, "Webdings", UPtp5h1_clr);
   ObjectSetText("joG015", UP06h1, 7, "Webdings", UPtp6h1_clr);

   ObjectSetText("joG028", SW01m30, 7, "Webdings", Midplusm30_clr);
   ObjectSetText("joG027", UP01m30, 7, "Webdings", UPtp1m30_clr);
   ObjectSetText("joG026", UP02m30, 7, "Webdings", UPtp2m30_clr);
   ObjectSetText("joG025", UP03m30, 7, "Webdings", UPtp3m30_clr);
   ObjectSetText("joG024", UP04m30, 7, "Webdings", UPtp4m30_clr);
   ObjectSetText("joG023", UP05m30, 7, "Webdings", UPtp5m30_clr);
   ObjectSetText("joG022", UP06m30, 7, "Webdings", UPtp6m30_clr);

   ObjectSetText("joG035", SW01m15, 7, "Webdings", Midplusm15_clr);
   ObjectSetText("joG034", UP01m15, 7, "Webdings", UPtp1m15_clr);
   ObjectSetText("joG033", UP02m15, 7, "Webdings", UPtp2m15_clr);
   ObjectSetText("joG032", UP03m15, 7, "Webdings", UPtp3m15_clr);
   ObjectSetText("joG031", UP04m15, 7, "Webdings", UPtp4m15_clr);
   ObjectSetText("joG030", UP05m15, 7, "Webdings", UPtp5m15_clr);
   ObjectSetText("joG029", UP06m15, 7, "Webdings", UPtp6m15_clr);

   ObjectSetText("joG042", SW01m5, 7, "Webdings", Midplusm5_clr);
   ObjectSetText("joG041", UP01m5, 7, "Webdings", UPtp1m5_clr);
   ObjectSetText("joG040", UP02m5, 7, "Webdings", UPtp2m5_clr);
   ObjectSetText("joG039", UP03m5, 7, "Webdings", UPtp3m5_clr);
   ObjectSetText("joG038", UP04m5, 7, "Webdings", UPtp4m5_clr);
   ObjectSetText("joG037", UP05m5, 7, "Webdings", UPtp5m5_clr);
   ObjectSetText("joG036", UP06m5, 7, "Webdings", UPtp6m5_clr);

   ObjectSetText("joG049", SW01m1, 7, "Webdings", Midplusm1_clr);
   ObjectSetText("joG048", UP01m1, 7, "Webdings", UPtp1m1_clr);
   ObjectSetText("joG047", UP02m1, 7, "Webdings", UPtp2m1_clr);
   ObjectSetText("joG046", UP03m1, 7, "Webdings", UPtp3m1_clr);
   ObjectSetText("joG045", UP04m1, 7, "Webdings", UPtp4m1_clr);
   ObjectSetText("joG044", UP05m1, 7, "Webdings", UPtp5m1_clr);
   ObjectSetText("joG043", UP06m1, 7, "Webdings", UPtp6m1_clr);

   ObjectSetText("joTP1", TP1, 8, "Arial Bold", TP_clr);
   ObjectSetText("joTP2", TP2, 8, "Arial Bold", TP_clr);
   ObjectSetText("joTP3", TP3, 8, "Arial Bold", TP_clr);

//*****************************************************************************************************
 //----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int CreateOL( string n, int xoff, int yoff ) {
   ObjectCreate( n, OBJ_LABEL, window, 0, 0 );
   ObjectSet( n, OBJPROP_CORNER, corner );
   ObjectSet( n, OBJPROP_XDISTANCE, xoff );
   ObjectSet( n, OBJPROP_YDISTANCE, yoff );
   ObjectSet( n, OBJPROP_BACK, false );
}


int init()
  {

//---- 
   IndicatorShortName("+JoGET#58+");  
//---- indicators
   int top = 0;
   int left = 0;


   CreateOL( "joPVD1t", left+250, top+15 );
   CreateOL( "joPVD1a", left+250, top+25 );
   CreateOL( "joOPD1t", left+300, top+15 );
   CreateOL( "joOPD1a", left+300, top+25 );
   CreateOL( "joP2Opent", left+350, top+15 );
   CreateOL( "joP2Opena", left+350, top+25 );
   CreateOL( "joHILOt", left+380, top+15 );
   CreateOL( "joHILOa", left+380, top+25 );
   CreateOL( "joDAVt", left+410, top+15 );
   CreateOL( "joDAVa", left+410, top+25 );
   CreateOL( "joSpreadt", left+440, top+15 );
   CreateOL( "joSpreada", left+440, top+25 );
   CreateOL( "joPair", left+470, top+15 );

   CreateOL( "joFast", left+135, top+46 );
   CreateOL( "joSignal", left+83, top+46 );
   CreateOL( "joTrend", left+40, top+46 );
   CreateOL( "xCandle", left+170, top+32 );
   CreateOL( "pric3", left+170, top+7 );

   CreateOL( "joSignalM1", left+148, top+28 );
   CreateOL( "joSignalM5", left+130, top+28 );
   CreateOL( "joSignalM15", left+112, top+28 );
   CreateOL( "joSignalM30", left+94, top+28 );
   CreateOL( "joSignalH1", left+76, top+28 );
   CreateOL( "joSignalH4", left+58, top+28 );
   CreateOL( "joSignalD1", left+40, top+28 );

   CreateOL( "jobbaoTM1", left+151, top+10 );
   CreateOL( "jobbaoTM5", left+133, top+10 );
   CreateOL( "jobbaoTM15", left+115, top+10 );
   CreateOL( "jobbaoTM30", left+97, top+10 );
   CreateOL( "jobbaoTH1", left+79, top+10 );
   CreateOL( "jobbaoTH4", left+61, top+10 );
   CreateOL( "jobbaoTD1", left+43, top+10 );

   CreateOL( "jobbaoBSM1", left+148, top+10 );
   CreateOL( "jobbaoBSM5", left+130, top+10 );
   CreateOL( "jobbaoBSM15", left+112, top+10 );
   CreateOL( "jobbaoBSM30", left+94, top+10 );
   CreateOL( "jobbaoBSH1", left+76, top+10 );
   CreateOL( "jobbaoBSH4", left+58, top+10 );
   CreateOL( "jobbaoBSD1", left+40, top+10 );

   CreateOL( "joTex1", left+151, top+28 );
   CreateOL( "joTex2", left+133, top+28 );
   CreateOL( "joTex3", left+115, top+28 );
   CreateOL( "joTex4", left+97, top+28 );
   CreateOL( "joTex5", left+79, top+28 );
   CreateOL( "joTex6", left+61, top+28 );
   CreateOL( "joTex7", left+43, top+28 );

   CreateOL( "joG07", left+43, top+62 );
   CreateOL( "joG06", left+43, top+67 );
   CreateOL( "joG05", left+43, top+74 );
   CreateOL( "joG04", left+43, top+81 );
   CreateOL( "joG03", left+43, top+88 );
   CreateOL( "joG02", left+43, top+95 );
   CreateOL( "joG01", left+43, top+102 );

   CreateOL( "joG014", left+61, top+62 );
   CreateOL( "joG013", left+61, top+67 );
   CreateOL( "joG012", left+61, top+74 );
   CreateOL( "joG011", left+61, top+81 );
   CreateOL( "joG010", left+61, top+88 );
   CreateOL( "joG09", left+61, top+95 );
   CreateOL( "joG08", left+61, top+102 );

   CreateOL( "joG021", left+79, top+62 );
   CreateOL( "joG020", left+79, top+67 );
   CreateOL( "joG019", left+79, top+74 );
   CreateOL( "joG018", left+79, top+81 );
   CreateOL( "joG017", left+79, top+88 );
   CreateOL( "joG016", left+79, top+95 );
   CreateOL( "joG015", left+79, top+102 );

   CreateOL( "joG028", left+97, top+62 );
   CreateOL( "joG027", left+97, top+67 );
   CreateOL( "joG026", left+97, top+74 );
   CreateOL( "joG025", left+97, top+81 );
   CreateOL( "joG024", left+97, top+88 );
   CreateOL( "joG023", left+97, top+95 );
   CreateOL( "joG022", left+97, top+102 );

   CreateOL( "joG035", left+115, top+62 );
   CreateOL( "joG034", left+115, top+67 );
   CreateOL( "joG033", left+115, top+74 );
   CreateOL( "joG032", left+115, top+81 );
   CreateOL( "joG031", left+115, top+88 );
   CreateOL( "joG030", left+115, top+95 );
   CreateOL( "joG029", left+115, top+102 );

   CreateOL( "joG042", left+133, top+62 );
   CreateOL( "joG041", left+133, top+67 );
   CreateOL( "joG040", left+133, top+74 );
   CreateOL( "joG039", left+133, top+81 );
   CreateOL( "joG038", left+133, top+88 );
   CreateOL( "joG037", left+133, top+95 );
   CreateOL( "joG036", left+133, top+102 );

   CreateOL( "joG049", left+151, top+62 );
   CreateOL( "joG048", left+151, top+67 );
   CreateOL( "joG047", left+151, top+74 );
   CreateOL( "joG046", left+151, top+81 );
   CreateOL( "joG045", left+151, top+88 );
   CreateOL( "joG044", left+151, top+95 );
   CreateOL( "joG043", left+151, top+102 );

   CreateOL( "joTP1", left+5, top+73 );
   CreateOL( "joTP2", left+5, top+84 );
   CreateOL( "joTP3", left+5, top+95 );

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("joFast");   ObjectDelete("joSignal");
   ObjectDelete("joTrend");   ObjectDelete("joSignalM1");
   ObjectDelete("joSignalM5");   ObjectDelete("joSignalM15");
   ObjectDelete("joSignalM30");   ObjectDelete("joSignalH1");
   ObjectDelete("joSignalH4");   ObjectDelete("joSignalD1");
   ObjectDelete("jobbaoTM1");   ObjectDelete("jobbaoTM5");
   ObjectDelete("jobbaoTM15");   ObjectDelete("jobbaoTM30");
   ObjectDelete("jobbaoTH1");   ObjectDelete("jobbaoTH4");
   ObjectDelete("jobbaoTD1");   ObjectDelete("jobbaoBSM1");
   ObjectDelete("jobbaoBSM5");   ObjectDelete("jobbaoBSM15");
   ObjectDelete("jobbaoBSM30");   ObjectDelete("jobbaoBSH1");
   ObjectDelete("jobbaoBSH4");   ObjectDelete("jobbaoBSD1");
   ObjectDelete("joTex1");   ObjectDelete("joTex2");
   ObjectDelete("joTex3");   ObjectDelete("joTex4");
   ObjectDelete("joTex5");   ObjectDelete("joTex6");
   ObjectDelete("joTex7");   ObjectDelete("xCandle");
   ObjectDelete("pric3");   ObjectDelete("joPair");
   ObjectDelete("joPVD1t");   ObjectDelete("joPVD1a");
   ObjectDelete("joOPD1t");   ObjectDelete("joOPD1a");
   ObjectDelete("joP2Opent");   ObjectDelete("joP2Opena");
   ObjectDelete("joHILOt");   ObjectDelete("joHILOa");
   ObjectDelete("joDAVt");   ObjectDelete("joDAVa");
   ObjectDelete("joSpreadt");   ObjectDelete("joSpreada");
   ObjectDelete("joG01");   ObjectDelete("joG02");
   ObjectDelete("joG03");   ObjectDelete("joG04");
   ObjectDelete("joG05");   ObjectDelete("joG06");
   ObjectDelete("joG07");   ObjectDelete("joG08");
   ObjectDelete("joG09");   ObjectDelete("joG010");
   ObjectDelete("joG011");   ObjectDelete("joG012");
   ObjectDelete("joG013");   ObjectDelete("joG014");
   ObjectDelete("joG015");   ObjectDelete("joG016");
   ObjectDelete("joG017");   ObjectDelete("joG018");
   ObjectDelete("joG019");   ObjectDelete("joG020");
   ObjectDelete("joG021");   ObjectDelete("joG022");
   ObjectDelete("joG023");   ObjectDelete("joG024");
   ObjectDelete("joG025");   ObjectDelete("joG026");
   ObjectDelete("joG027");   ObjectDelete("joG028");
   ObjectDelete("joG029");   ObjectDelete("joG030");
   ObjectDelete("joG031");   ObjectDelete("joG032");
   ObjectDelete("joG033");   ObjectDelete("joG034");
   ObjectDelete("joG035");   ObjectDelete("joG036");
   ObjectDelete("joG037");   ObjectDelete("joG038");
   ObjectDelete("joG039");   ObjectDelete("joG040");
   ObjectDelete("joG041");   ObjectDelete("joG042");
   ObjectDelete("joG043");   ObjectDelete("joG044");
   ObjectDelete("joG045");   ObjectDelete("joG046");
   ObjectDelete("joG047");   ObjectDelete("joG048");
   ObjectDelete("joG049");   ObjectDelete("joG050");
   ObjectDelete("joG051");   ObjectDelete("joG052");
   ObjectDelete("joG053");   ObjectDelete("joG054");
   ObjectDelete("joG055");   ObjectDelete("joG056");
   ObjectDelete("joTP1");   ObjectDelete("joTP2");
   ObjectDelete("joTP3");   
//----
   return(0);
  }
//+------------------------------------------------------------------+

